#include <stdio.h>
#include <rpc/rpc.h>
#include "cfxdr.h"

XDR_element	xdrfile[MAX_N_XDR_FILES] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
	
	long
#ifdef cray
	CXDRINIT( int *fname_len, char *filename, int *mode )

#elif defined(hpux)
	cxdrinit( fname_len, filename, mode )
	int	*fname_len;
	char	*filename;
	int	*mode;

#else
	cxdrinit_( int *fname_len, char *filename, int *mode )
#endif
{
	FILE	*f;
	int	xdr_mode, new_xdr_id;
	XDR	*xdrs;
	char	local_filename[256];

	strncpy( local_filename, filename, *fname_len );
	local_filename[*fname_len] = '\0';

	/* Get the new XDR ID to use when accessing this file */
	if( (new_xdr_id = cxdrgetid()) == -1 ) {
		fprintf( stderr, "Error while trying to open file %s\n",
				local_filename );
		exit( -1 );
		}

	/* Save the file name of this XDR file, so that we
	 * can print it out in case of errors.
	 */
	xdrfile[new_xdr_id].filename = (char *)
			malloc(sizeof(char)*(*fname_len + 1));
	strcpy( xdrfile[new_xdr_id].filename, local_filename );

	xdrs = (XDR *)malloc( sizeof( XDR ) );
	if( xdrs == NULL ) {
		fprintf( stderr, "Error on xdr stream create\n" );
		fprintf( stderr, "filename=%s\n", local_filename );
		exit( -1 );
		}

	if( *mode == 1 ) {
		xdr_mode = XDR_DECODE;
		if( (f = fopen( local_filename, "r" )) == NULL ) {
			fprintf( stderr, 
				"Error opening XDR file \"%s\" for reading\n",
				local_filename );
			perror( "Reason" );
			exit( -1 );
			}
		}
	else if( *mode == 2 )
		{
		xdr_mode = XDR_ENCODE;
		if( (f = fopen( local_filename, "w" )) == NULL ) {
			fprintf( stderr, 
				"Error opening XDR file \"%s\" for writing\n",
				local_filename );
			perror( "Reason" );
			exit( -1 );
			}
		}
	else
		{
		fprintf( stderr, "error: cxdrinit.c called with mode=%ld\n", *mode );
		exit( -1 );
		}
	
	xdrstdio_create( xdrs, f, xdr_mode );

	xdrfile[new_xdr_id].xdrs = xdrs;

	/* Add the file pointer to the user's data area so
	 * that we can close the file when the destroy routine
	 * is called!
	 */
	xdrs->x_public = (caddr_t)f;
/*
  fprintf(f,"\f\f");
	printf("Testing area in create\n");
  fprintf(f,"# AVS field file\n");
  fprintf(f,"ndim = 3\n");
  fprintf(f,"dim1 = 33\n");
  fprintf(f,"dim2 = 33\n");
  fprintf(f,"dim3 = 65\n");
  fprintf(f,"nspace = 3\n");
  fprintf(f,"veclen = 1\n");
  fprintf(f,"data = xdr_float\n");
  fprintf(f,"field = uniform\n");
*/
	return( new_xdr_id );
}

	int
cxdrgetid()
{
	int	i;

	i = 0;
	while( xdrfile[i].filename != NULL ) {
		i++;
		if( i >= MAX_N_XDR_FILES ) {
			fprintf( stderr, "FXDR library error: too many ");
			fprintf( stderr, "XDR files open! Max is %d\n",
				MAX_N_XDR_FILES );
			return( -1 );
			}
		}
	return( i );
}
